; GUI #
include win64a.inc
; --------------- 
WINDOWWIDTH		= 573
WINDOWHEIGHT		= 518
ANTIALIASED_QUALITY	= 4

.code
WinMain	proc
local	msg:MSG

	xor	ebx,ebx
        mov	edi,offset szClassName
        mov	esi,IMAGE_BASE
        mov	ecx,offset FileName
	invoke	LoadCursorFromFile
        push	rax	;hIconSm
	push	rdi	;lpszClassName
	push	rbx	;lpszMenuName
	push	COLOR_WINDOWTEXT+1;hbrBackground
	push	rax	;hCursor
	push	rax        ;hIcon
	push	rsi	;hInstance
	push	rbx        ;cbClsExtra & cbWndExtra
	pushaddr WndProc;lpfnWndProc
	mov	rax,(CS_HREDRAW or CS_VREDRAW or CS_OWNDC)shl 32 \
	or (sizeof WNDCLASSEX)
	push	rax	;cbSize & style
    	invoke	RegisterClassEx,esp	;addr WNDCLASSEX
	
	push	rbx
	push	rsi	;rsi = 400000h
	shl	esi,9	;rsi = CW_USEDEFAULT
	push	rbx
	push	rbx
	push	WINDOWHEIGHT
	push	WINDOWWIDTH
	push	rsi
	push	rsi
	sub	esp,20h
    	invoke	CreateWindowEx,0,edi,edi,WS_OVERLAPPEDWINDOW or \
	WS_CLIPCHILDREN or WS_CLIPSIBLINGS or WS_VISIBLE
; 
    	lea	edi,msg
@@:	invoke	GetMessage,edi,0,0,0	
	invoke	DispatchMessage,edi
	jmp	@b
WinMain endp
WndProc	proc	hWin:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local	ps:PAINTSTRUCT
local	w:dword
local	h:dword

        mov	hWin,rcx

        cmp	edx,WM_CREATE
	je      wmCREATE
        cmp	edx,WM_SIZE
	je      wmSIZE
        cmp	edx,WM_PAINT
	je      wmPAINT
	cmp	edx,WM_TIMER
	je	wmTIMER
        cmp	edx,WM_DESTROY
	je      wmDESTROY
        cmp	edx,WM_KEYDOWN
	je      wmKEYDOWN          
default:leave
	jmp	NtdllDefWindowProc_
wmKEYDOWN:mov	al,r8b;wParam
	cmp	al,VK_ESCAPE;user press 'Esc'?
	jne	wmBYE
wmDESTROY:invoke wglMakeCurrent,0,0
	invoke	wglDeleteContext,hRC
	invoke	ReleaseDC,hWin,hDC
;KillFont---------------------------
	mov	ecx,base
	invoke	glDeleteLists,,96; Delete All 96 Characters
;-----------------------------------------
;    
	mov	ecx,list_base
	invoke	glDeleteLists,,128
	mov	edx,textures
	invoke	glDeleteTextures,128
	mov	ecx,textures
	invoke	GlobalFree
;-----------------------------------------
	invoke	KillTimer,hWin,10
	invoke	RtlExitUserProcess,NULL
;------------------------------
wmTIMER:movq	xmm0,constd0_21
	addsd	xmm0,cnt1
	movq	cnt1,xmm0; Increase the counter
        invoke	InvalidateRect,,0,0
	jmp	wmBYE
;-----------------------------------------	
wmCREATE:invoke	GetDC ;  
	mov	hDC,rax
;    OpenGL ( OpenGL   
;)  
        mov	edx,offset PixFrm
	invoke	ChoosePixelFormat,eax
;  
	mov	r8d,offset PixFrm
	invoke	SetPixelFormat,hDC,eax
;     OpenGL
	invoke	wglCreateContext,hDC
	mov	hRC,rax
;   
	invoke	wglMakeCurrent,hDC,eax
	invoke	SetTimer,hWin,10,25,0;  #10  25 mSec
;-------------------------------------------------------
	invoke	glShadeModel,GL_SMOOTH; Enable Smooth Shading
	movss	xmm3,const0_5
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glClearColor; Black Background
	movsd	xmm0,constd1
	invoke	glClearDepth; Depth Buffer Setup
	invoke	glEnable,GL_DEPTH_TEST; Enables Depth Testing
	invoke	glDepthFunc,GL_LEQUAL; The Type Of Depth Testing To Do
	invoke	glHint,GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST; Really Nice Perspective Calculations
	invoke	BuildFont; Build The Font
	invoke	init;,,16;Build the freetype font
;--------------------------------------------------------
        mov	r9d,(WINDOWHEIGHT shl 16)or WINDOWWIDTH 
wmSIZE:; --------------- Resize the scene
	movzx	r8,r9w
	mov	w,r8d
	shr	r9d,16
	mov	h,r9d
	invoke	glViewport,0,0; Reset The Current Viewport

	invoke	glMatrixMode,GL_PROJECTION; Select The Projection Matrix
	invoke	glLoadIdentity; Reset The Projection Matrix

; Calculate The Aspect Ratio Of The Window
	movq	xmm3,constd100
	movq	xmm2,constd0_1
	cvtsi2sd xmm1,w
	cvtsi2sd xmm0,h
	divsd	xmm1,xmm0
	movq	xmm0,constd45
	invoke	gluPerspective

	invoke	glMatrixMode,GL_MODELVIEW; Select The Modelview Matrix
	invoke	glLoadIdentity; Reset The Modelview Matrix	
        jmp	wmBYE
wmPAINT:; No pending messages: draw the scene
	lea	edx,ps
	invoke	BeginPaint
; --------------- Display the scene
	invoke	glClear,GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT; Clear Screen And Depth Buffer
	invoke	glLoadIdentity; Reset The Current Modelview Matrix
	movss	xmm2,const_1
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTranslatef; Move One Unit Into The Screen
;------------------------------------
	invoke	glColor3ub,0,0,0FFh
	invoke	glMatrixMode,GL_PROJECTION; Select The Projection Matrix
	invoke	glLoadIdentity ; Reset The Projection Matrix
	invoke	glMatrixMode,GL_MODELVIEW; Select The Modelview Matrix
	invoke	glLoadIdentity; Reset The Modelview Matrix
; Position The WGL Text On The Screen
	movss	xmm1,const0_85
	movss	xmm0,const_0_84;x
	invoke	glRasterPos2f
        mov	ecx,offset fmt1;"Active WGL Bitmap Text With NeHe - %7.2f"
	invoke	glPrint; Print GL Text To The Screen
;------------------------------------
	invoke	glColor3ub,0FFh,0,0
	invoke	glMatrixMode,GL_PROJECTION; Select The Projection Matrix
	invoke	glLoadIdentity ; Reset The Projection Matrix
	invoke	glMatrixMode,GL_MODELVIEW; Select The Modelview Matrix
	invoke	glLoadIdentity; Reset The Modelview Matrix

	movss	xmm3,const1     ;                                     |
	xorps	xmm2,xmm2       ;                                     |
	xorps	xmm1,xmm1       ;                                     |
	cvtsd2ss xmm0,cnt1      ;                                     |
	invoke	glRotatef

	xorps	xmm2,xmm2       ;                                     |
	xorps	xmm1,xmm1       ;                                     |
	movss	xmm0,const_180  ;                                     |
	invoke	glTranslatef    ;                                     |
	invoke	print           ;                                     |
;-----------------------------------------
;   
        invoke	SwapBuffers,hDC
        lea	edx,ps
	invoke	EndPaint,hWin
wmBYE:	leave
	retn	
WndProc	endp
print proc
local	text[64]:byte;  
local	modelview_matrix[16]:dword
local   viewport[4]:dword
local	len:dword
						                      
	lea	r8d,cnt1
	mov	edx,offset fmt2 ;"Active FreeType Text - %7.2f"       |
	lea	ecx,text
	invoke	vsprintf
	mov	len,eax

	invoke	glPushAttrib,GL_TRANSFORM_BIT
	lea	edx,viewport
	invoke	glGetIntegerv,GL_VIEWPORT
	invoke	glMatrixMode,GL_PROJECTION
	invoke	glPushMatrix
	invoke	glLoadIdentity

	cvtsi2sd xmm3,viewport[3*4];bottom = height
	cvtsi2sd xmm2,viewport[1*4];top    = y
	cvtsi2sd xmm1,viewport[2*4];right  = width
	cvtsi2sd xmm0,viewport[0*4];left   = x
	invoke	gluOrtho2D
	invoke	glPopAttrib

	invoke	glPushAttrib,GL_LIST_BIT or GL_CURRENT_BIT or GL_ENABLE_BIT or GL_TRANSFORM_BIT
	invoke	glMatrixMode,GL_MODELVIEW
	invoke	glDisable,GL_LIGHTING
	invoke	glEnable,GL_TEXTURE_2D
	invoke	glDisable,GL_DEPTH_TEST

	invoke	glEnable,GL_BLEND
	invoke	glBlendFunc,GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA
	mov	ecx,list_base
	invoke	glListBase

	lea	edx,modelview_matrix
	invoke	glGetFloatv,GL_MODELVIEW_MATRIX
;       . 
;     .  
;     h,    
;     , 
;      
	invoke	glPushMatrix
	invoke	glLoadIdentity
	xorps	xmm2,xmm2
	movss	xmm1,const240
        movss	xmm0,const270
	invoke	glTranslatef
	lea	ecx,modelview_matrix
	invoke	glMultMatrixf

	lea	r8d,text
	mov	ecx,len
	invoke	glCallLists,,GL_UNSIGNED_BYTE
	invoke	glPopMatrix

	invoke	glPopAttrib
;   
	invoke	glPushAttrib,GL_TRANSFORM_BIT
	invoke	glMatrixMode,GL_PROJECTION
	invoke	glPopAttrib
	leave
	retn
print endp
;      h   fname
init proc 
local	face:qword;FT_Face
local	library:qword;FT_Library
local	buf[10h]:dword
;    .
;textures = new GLuint[128]
	invoke	GlobalAlloc,GMEM_ZEROINIT or GMEM_FIXED,128*4
	mov	textures,eax
;  FreeType
	lea	ecx,library
	invoke	FT_Init_FreeType;eax=0
;   
	lea	r9d,face
	mov	edx,offset aTest_TTF;"test.TTF"
	invoke	FT_New_Face,library,,0;eax=0
;FreeType     1/64 ,     14 , 
;  14*64
	mov	r9d,96
	mov	[rsp+20h],r9
	invoke	FT_Set_Char_Size,face,14*64,14*64;eax=0
; OpenGL,         ,   
	invoke	glGenLists,128
	mov	list_base,eax

	mov	edx,textures
	invoke	glGenTextures,128
;   
	invoke	make_dlist,face
; 
	invoke	FT_Done_Face,face
; 
	invoke	FT_Done_FreeType,library
	leave
	retn
init endp
;Create a display list coresponding to the give character
make_dlist proc face:dword
local	charcode:dword
local	y:qword
local	x:qword
local	expanded_data:dword
local	height:dword
local	width_:dword
local	bitmap:dword;FT_Bitmap
local	bitmap_glyph:dword;FT_BitmapGlyph
local	glyph:dword;FT_Glyph
local	buf[10h]:dword

	mov	face,ecx
	and	charcode,0
;     
;    
@3:	invoke	FT_Get_Char_Index,face,charcode;   eax=0
	invoke	FT_Load_Glyph,face,eax,FT_LOAD_DEFAULT;eax=0
;   
	lea	edx, glyph
	mov	ecx, face
        mov	rcx,[rcx].FT_FaceRec.glyph ; face->glyph [esi+54h]  6730700h
	invoke	FT_Get_Glyph; eax=0
;   
	lea	ecx, glyph
	invoke	FT_Glyph_To_Bitmap,,FT_RENDER_MODE_NORMAL,0,1 ; eax=0
	mov	esi, glyph
	mov	bitmap_glyph, esi
;   ,     
;       FT_BitmapGlyph bitmap_glyph = (FT_BitmapGlyph)glyph
;	add	esi,24h;
	lea	esi,[rsi].FT_BitmapGlyphRec.bitmap; +24h
	mov	bitmap, esi;FT_Bitmap& bitmap=bitmap_glyph->bitmap
;        
	mov	edx,[rsi].FT_Bitmap.width_;
	invoke	next_p2
	mov	width_, eax ;int width = next_p2( bitmap.width )
	mov	edx,[rsi].FT_Bitmap.rows
	invoke	next_p2
	mov	height, eax;int height = next_p2( bitmap.rows )
;    
	mul	width_
	add	eax,eax
	invoke	GlobalAlloc,GMEM_ZEROINIT or GMEM_FIXED,eax
	mov	expanded_data, eax;GLubyte* expanded_data = new GLubyte[ 2 * width * height]
;    .
;   (       ),   
;    ,     FreeType.
;  ?:     0     FreeType
;  for(int j=0; j <height;j++) {
;    for(int i=0; i < width; i++){
;      expanded_data[2 * (i + j * width)]=255; 
;      expanded_data[2 * (i + j * width) + 1] =
;        (i >= bitmap.width || j >= bitmap.rows) ? 0 : bitmap.buffer[i + bitmap.width * j];
;    }
;  }
	xor	esi,esi;j=esi
@0:	xor	edi,edi;i=edi
@1:	mov	edx, bitmap
	cmp	edi, [rdx].FT_Bitmap.width_;if (i >= bitmap.width)
	jae	@f
	cmp	esi, [rdx].FT_Bitmap.rows;if(j >= bitmap.rows)
	jb	@2
@@:	xor	edx, edx
	jmp	@f
; ---------------------------------------------------------------------------
@2:	mov	eax,[rdx].FT_Bitmap.width_
	imul	eax,esi;eax = bitmap.width * j
	mov	rcx,[rdx].FT_Bitmap.buffer
	add	ecx,edi;ecx = bitmap.buffer + i
	mov	dl,[rcx+rax];dl = bitmap.buffer + i + bitmap.width * j
@@:	mov	eax,esi
	imul	eax,width_;eax = bitmap.width * j
	add	eax,edi   ;eax = i + bitmap.width * j
	mov	ecx,expanded_data
	mov	[rcx+rax*2+1],dl;expanded_data[2 * (i + j * width) + 1]
	mov	byte ptr [rcx+rax*2],dl
	inc	edi
	cmp	edi,width_
	jb	@1
	inc	esi
	cmp	esi,height
	jb	@0
;  ,     OpenGL.    ,  
;,     ,     (   
;     ).
;     
	mov	edx,charcode
	mov	eax,textures
	mov	edx,[rax+rdx*4]
	invoke	glBindTexture,GL_TEXTURE_2D
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR
;   
; ,   GL_LUMINANCE_ALPHA,      

	xor	edx,edx
	mov	eax,expanded_data
	mov	[rsp+40h],rax
	mov	qword ptr[rsp+38h],GL_UNSIGNED_BYTE
	mov	qword ptr[rsp+30h],GL_LUMINANCE_ALPHA
	mov	[rsp+28h],rdx
	mov	eax,height
	mov	[rsp+20h],rax
	mov	r9d,width_
	invoke	glTexImage2D,GL_TEXTURE_2D,,GL_RGBA
;  ,       
	invoke	GlobalFree,expanded_data
;        .   , 
;     / ,        
; OpenGL (        ).
;   

	mov	ecx, charcode
	add	ecx,list_base;[rcx]
	invoke	glNewList,,GL_COMPILE;glNewList(list_base+ch,GL_COMPILE)

	mov	edx,charcode
	mov	eax,textures
	mov	edx,[rax+rdx*4]
	invoke	glBindTexture,GL_TEXTURE_2D;glBindTexture(GL_TEXTURE_2D,tex_base[ch])        
;            
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	mov	esi, bitmap_glyph
	cvtsi2ss xmm0,dword ptr [rsi].FT_BitmapGlyphRec.left;[rdx+14h]
	invoke	glTranslatef;glTranslatef(bitmap_glyph->left,0,0)
;    ,     .
;     ,   'g'  'y'
	invoke	glPushMatrix

	xorps	xmm2,xmm2
	mov	eax, [rsi].FT_BitmapGlyphRec.top
	mov	esi, bitmap
	sub	eax, [rsi].FT_Bitmap.rows	; top - bitmap.rows
	cvtsi2ss xmm1,eax
	xorps	xmm0,xmm0
	invoke	glTranslatef;0, bitmap_glyph->top - bitmap.rows,0)

;        .
;      ,    ,     
; x  y, ,    ,        
;,     
;	mov	ecx, bitmap
	cvtsi2sd xmm1,[rsi].FT_Bitmap.width_
	cvtsi2sd xmm0,width_
	divsd	xmm1,xmm0
	movsd	x,xmm1		; x=(float)bitmap.width	/ (float)width
	cvtsi2sd xmm1,[rsi].FT_Bitmap.rows
	cvtsi2sd xmm0,height
	divsd	xmm1,xmm0
	movsd	y,xmm1		; y=(float)bitmap.rows / (float)height
;  
	invoke	glBegin,GL_QUADS
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTexCoord2d;glTexCoord2d(0,0)
	cvtsi2ss xmm1,[rsi].FT_Bitmap.rows
	xorps	xmm0,xmm0
	invoke	glVertex2f;glVertex2f(0,bitmap.rows)
	movsd	xmm1,y
	xorps	xmm0,xmm0
	invoke	glTexCoord2d;glTexCoord2d(0,y)
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glVertex2f;glVertex2f(0,0)
	movsd 	xmm1,y
	movsd	xmm0,x
	invoke	glTexCoord2d;glTexCoord2d(x,y)
	xorps	xmm1,xmm1
	cvtsi2ss xmm0,[rsi].FT_Bitmap.width_
	invoke	glVertex2f;glVertex2f(bitmap.width,0)
	xorps	xmm1,xmm1
	movsd	xmm0,x
	invoke	glTexCoord2d
	cvtsi2ss xmm1,[rsi].FT_Bitmap.rows
	cvtsi2ss xmm0,[rsi].FT_Bitmap.width_
	invoke	glVertex2f
	invoke	glEnd
	invoke	glPopMatrix

	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	mov	ecx,face
	mov	rcx,[rcx].FT_FaceRec.glyph
	mov	ecx,[rcx+58h];glyph->advance.x
	sar	ecx,6		
	cvtsi2ss xmm0,ecx
	invoke	glTranslatef;glTranslatef(face->glyph->advance.x >> 6 ,0,0)
;    
	invoke	glEndList
	inc	charcode
	cmp	charcode,128
	jb	@3
	leave
	retn
make_dlist endp
; ---------------------------------------------------------------------------
;      , ,   a
next_p2 proc ;a:dword
	mov	eax,1
	cmp	edx,eax
	jle	@f
	bsr	ecx,edx	
	shl	eax,cl
	cmp	eax,edx
	je	@f
	add	eax,eax
@@:	retn
next_p2 endp
BuildFont proc
local	font:dword
local	oldfont:dword

	invoke	glGenLists,96; Storage For 96 Characters
	mov	base,eax
	xor	edx,edx
	pushaddr FontName;"Times New Roman"
	push	rdx;(FF_DONTCARE or DEFAULT_PITCH) = 0; Family and pitch
	push	ANTIALIASED_QUALITY; Output Quality
	push	rdx;CLIP_DEFAULT_PRECIS=0; Clipping Precision
	push	OUT_TT_PRECIS; Output Precision
	push	rdx;ANSI_CHARSET=0; Character Set Identifier
	push	rdx;Strikeout
	push	rdx;Underline
	push	rdx;Italic
	push	FW_BOLD; Font Weight
	sub	esp,20h
	mov	ecx,-24
	invoke	CreateFont,,,0,0
	mov	font,eax
	invoke	SelectObject,hDC,eax; Selects The Font We Want
	mov	oldfont,eax
	mov	r9d, base
	invoke	wglUseFontBitmapsA,hDC, 32, 96; Builds 96 Characters Starting At Character 32
	invoke	SelectObject,hDC, oldfont; Selects The Font We Want
	invoke	DeleteObject,font; Delete The Font
	leave
	retn
BuildFont endp
glPrint proc  fmt:dword;,ap:qword; Custom GL "Print" Routine
local	text[256]:byte; Holds our string
local	len:dword

	or	ecx,ecx;if (fmt == NULL) if there's no text
	jz	exit0; do nothing
        lea	r8d,cnt1
	mov	edx,ecx;fmt
	lea	ecx,text; parses The String For Variables
	invoke	vsprintf; and Converts Symbols to actual numbers
	mov	len,eax; results are stored in text

	invoke	glPushAttrib,GL_LIST_BIT; Pushes The Display List Bits
	mov	ecx,base
	sub	ecx,32; Sets The Base Character to 32
	invoke	glListBase
	lea	r8d, text
	mov	ecx,len
	invoke	glCallLists,,GL_UNSIGNED_BYTE; Draws The Display List Text
	invoke	glPopAttrib; Pops The Display List Bits
exit0:	leave
	retn
glPrint endp
;---------------------------------------------------------------------------
;align 10h
hDC	dq	?
hRC	dq	?
PixFrm	label	PIXELFORMATDESCRIPTOR 
	nSize             dw	sizeof PIXELFORMATDESCRIPTOR
  	nVersion          dw	1
  	dwFlags           dd	PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER or PFD_DRAW_TO_WINDOW
  	iPixelType        db	PFD_TYPE_RGBA
  	cColorBits        db	32;Select Our Color Depth
  	cRedBits          db	0
  	cRedShift         db	0
  	cGreenBits        db	0
  	cGreenShift       db	0
  	cBlueBits         db	0
  	cBlueShift        db	0;Color Bits Ignored
  	cAlphaBits        db	0;No Alpha Buffer
  	cAlphaShift       db	0;Shift Bit Ignored
  	cAccumBits        db	0;No Accumulation Buffer
  	cAccumRedBits     db	0
  	cAccumGreenBits   db	0
  	cAccumBlueBits    db	0
  	cAccumAlphaBits   db	0;Accumulation Bits Ignored
  	cDepthBits        db	16;16Bit Z-Buffer (Depth Buffer)
  	cStencilBits      db	0;No Stencil Buffer
  	cAuxBuffers       db	0;No Auxiliary Buffer
  	iLayerType        db	PFD_MAIN_PLANE;Main Drawing Layer
  	bReserved         db	0;Reserved
  	dwLayerMask       dd	0
  	dwVisibleMask     dd	0
  	dwDamageMask      dd	0;Layer Masks Ignored

szClassName	db "NeHe lesson#43: TrueType Font Tutorial",0
FileName	db "br_Rabbit3.cur",0
base		dd ?; Base Display List For The Font Set
FontName	db "Times New Roman",0
cnt1		dq ?
fmt1 		db "Active WGL Bitmap Text With NeHe - %7.2f",0 
fmt2 		db "Active FreeType Text - %7.2f",0
aTest_TTF 	db "test.TTF",0
;     FreeType ,    
textures	dd ?; 
list_base	dd ?;     
;-----------------------------
;float
const0_2	dd 0.2
const0_3	dd 0.3
const0_85	dd 0.85
const_0_84	dd -0.84
const0_5	dd 0.5
const0_8	dd 0.8
const1		dd 1.0
const_1		dd -1.0
const_180	dd -180.0
const240	dd 240.0
const270	dd 270.0
;double
constd0_1	dq 0.1
constd0_21	dq 0.21
constd1		dq 1.0
constd45	dq 45.0
constd100	dq 100.0
end